subroutine ml(string %latent1, string %latent2, coef bb, coef cc, coef rho, matrix cov, scalar loglik, scalar aic, scalar sc, scalar hq, scalar !start, scalar !hill, scalar !doanalytic)
	%lateq1 = ""
	%lateq2 = ""	
	call eqmake(%latent1,"bb",%lateq1)	'1st equation
	call eqmake(%latent2,"cc",%lateq2)	'2nd equation
	%dep1 = @word(%latent1,1)
	%dep2 = @word(%latent2,1)
	
	'Set up log likelihood
	!pi = @acos(-1) 
	logl ll1
	ll1.append @byobs
	ll1.append @logl logl1
	
	ll1.append x1b = {%lateq1} 
	ll1.append x2b = {%lateq2}		
	ll1.append s1 = (2*{%dep1}-1)
	ll1.append s2 = (2*{%dep2}-1)
	ll1.append s12 = s1*s2	
	ll1.append g1s = x1b*s1
	ll1.append g2s = x2b*s2
	
	'll1.append kappa = 1/2*@log( (1+rho(1)) / (1-rho(1)) ) 	
	ll1.append kappa = @atan(rho(1))*2/!pi 
	ll1.append rhos = kappa*s12
	ll1.append b = @cbvnorm(g1s,g2s,rhos)	'likelihood contribution
	ll1.append logl1 = @log(b)	'log-likelihood

	%tempnames = "x1b x2b s1 s2 s12 g1s g2s rhos del v1 v2 g1i g2i b kappa logl1"					
		
	if !doanalytic = 1 then	
		ll1.append  i1mr2 = 1/@sqrt(1-rhos*rhos)
		ll1.append 	v1 = (g2s- rhos*g1s)*i1mr2
		ll1.append 	v2 = (g1s- rhos*g2s)*i1mr2
		ll1.append 	c1=@cnorm(v1)
		ll1.append 	c2=@cnorm(v2)
		ll1.append 	d1=@dnorm(g1s)
		ll1.append 	d2=@dnorm(g2s)
		ll1.append factor1 = s1*c1*d1/b
		ll1.append factor2 = s2*c2*d2/b
		ll1.append drdk = 4*@exp(2*kappa)/(@exp(2*kappa)+1)^2		
		'derivative w.r.t. b
		%bderiv = ""
		for !i=1 to @wcount(%latent1)-1
			%var = @word(%latent1,!i+1)
			if @upper(%var) = "C" then
				%var = "1"
			endif
			ll1.append db{!i} = factor1*{%var}
			%bderiv = %bderiv + " bb(" + @str(!i) + ") " + "db" + @str(!i)
			%tempnames = %tempnames + " db" + @str(!i)
		next
		'derivative w.r.t. c
		%cderiv = ""
		for !i=1 to @wcount(%latent2)-1
			%var = @word(%latent2,!i+1)
			if @upper(%var) = "C" then
				%var = "1"
			endif
			ll1.append dc{!i} = factor2*{%var}
			%cderiv = %cderiv + " cc(" + @str(!i) + ") " + "dc" + @str(!i)
			%tempnames = %tempnames + " dc" + @str(!i)
		next		
		'derivative w.r.t. rho
		ll1.append dr = s12/b*@dbvnorm(g1s,g2s,rhos)/(1+rho(1)*rho(1))*2/!pi	
		%tempnames = %tempnames + " dr"			
		
		%derivs = %bderiv + " " + %cderiv + " rho(1) dr"		
		ll1.append @deriv {%derivs}		
	endif	
	ll1.append @temp {%tempnames}
	
	'do MLE and show results
	if !hill = 2 then
		ll1.ml(b, m=1000, c=1e-5, showopts)
	else
		ll1.ml(m=1000, c=1e-5, showopts)
	endif
	cov = ll1.@coefcov
	loglik = ll1.@logl
	aic = ll1.@aic
	sc = ll1.@sc
	hq = ll1.@hq
	d ll1
endsub

subroutine eqmake(string %spec, string %coef, string %speceq)
	%speceq = ""
	for !i=1 to @wcount(%spec)-1
		%word = @word(%spec,!i+1)
		if @upper(%word) = "C" then	'constant 
			%word = "1"
		endif
		%speceq = %speceq +  %coef + "(" + @str(!i) + ")*" + %word + " + "
	next
	%speceq = @left(%speceq,@len(%speceq)-3)
endsub
