
subroutine tablemake(string %tn, string %coefn, string %covarn, string %smpl, string %obs, string %latent1, string %latent2, scalar logl, scalar aic, scalar sc, scalar hq, scalar LR)
	!cols = 5
	%setformat = "f.4"
	%setformat1 = "f.6"
	!rows = @rows({%coefn}) + 10
	table(!rows,!cols) {%tn}
	{%tn}.setwidth(1) 19
	{%tn}.setwidth(2:5) 10
	{%tn}.setjust(a1:a5) left
	!rowcounter=1
	%title = "BivarIate Probit Regression (MLE)"
	{%tn}(!rowcounter,1) = %title
	!rowcounter = !rowcounter + 1
	%datestring = "Date: " + @datestr(@now,"MM/DD/YY") + "   Time: " + @datestr(@now,"HH:MI")
	{%tn}(!rowcounter,1) = %datestring
	!rowcounter=!rowcounter+1
	%samplestr = "Sample: " + %smpl
	{%tn}(!rowcounter,1) = %samplestr
	!rowcounter=!rowcounter+1
	%obsstr = "Included observations: " + %obs
	{%tn}(!rowcounter,1) = %obsstr
	!rowcounter=!rowcounter+1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	!rowcounter = !rowcounter + 1
	
	
	'--------------1ST Equation
	'column headers
	{%tn}(!rowcounter,1) = "First Latent Equation"
	{%tn}.setjust(!rowcounter,1) left
	!rowcounter = !rowcounter + 1
	%title = "Dependent Variable: " + @upper(@word(%latent1,1))
	{%tn}(!rowcounter,1) = %title
	!rowcounter = !rowcounter + 1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	{%tn}(!rowcounter,1) = "Variable"
	{%tn}(!rowcounter,2) = "Coefficient"
	{%tn}(!rowcounter,3) = "Std. Error"
	{%tn}(!rowcounter,4) = "z-Statistic"
	{%tn}(!rowcounter,5) = "Prob."
	!rowcounter=!rowcounter+1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	'row headers
	!temprow = !rowcounter
	for !i = 2 to @wcount(%latent1)
		{%tn}(!temprow,1) = @upper(@word(%latent1,!i))
		!temprow = !temprow+1
	next
	
	'coefficients etc..
	for !i=1 to @wcount(%latent1)-1  
		!coef = {%coefn}(!i)
		!covar = @sqrt({%covarn}(!i,!i))
		!tstat = !coef/!covar
		!pvalue = 2*(1-@cnorm(@abs(!tstat)))
		{%tn}(!rowcounter ,2) = !coef
		{%tn}(!rowcounter,3) = !covar
		{%tn}(!rowcounter,4) = !tstat
		{%tn}(!rowcounter,5) = !pvalue
		{%tn}.setformat(!rowcounter,2,!rowcounter,4) {%setformat1}
		{%tn}.setformat(!rowcounter,5) {%setformat}
		!rowcounter = !rowcounter + 1
	next
	
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	!rowcounter = !rowcounter + 1
	
	'--------------2ND Equation
	'column headers
	{%tn}(!rowcounter,1) = "Second Latent Equation"
	{%tn}.setjust(!rowcounter,1) left
	!rowcounter = !rowcounter + 1
	%title = "Dependent Variable: " + @upper(@word(%latent2,1))
	{%tn}(!rowcounter,1) = %title
	!rowcounter = !rowcounter + 1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	{%tn}(!rowcounter,1) = "Variable"
	{%tn}(!rowcounter,2) = "Coefficient"
	{%tn}(!rowcounter,3) = "Std. Error"
	{%tn}(!rowcounter,4) = "z-Statistic"
	{%tn}(!rowcounter,5) = "Prob."
	!rowcounter=!rowcounter+1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	'row headers
	!temprow = !rowcounter
	for !i = 2 to @wcount(%latent2)
		{%tn}(!temprow,1) = @upper(@word(%latent2,!i))
		!temprow = !temprow+1
	next
	
	'coefficients etc..
	!rowcounter = !rowcounter
	!row = @wcount(%latent1)-1
	for !i=1 to @wcount(%latent2)-1
		!j = !i + !row
		!coef = {%coefn}(!j)
		!covar = @sqrt({%covarn}(!j,!j))
		!tstat = !coef/!covar
		!pvalue = 2*(1-@cnorm(@abs(!tstat)))
		{%tn}(!rowcounter ,2) = !coef
		{%tn}(!rowcounter,3) = !covar
		{%tn}(!rowcounter,4) = !tstat
		{%tn}(!rowcounter,5) = !pvalue
		{%tn}.setformat(!rowcounter,2,!rowcounter,4) {%setformat1}
		{%tn}.setformat(!rowcounter,5) {%setformat}
		!rowcounter = !rowcounter + 1
	next
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	'---------------------Error Summary
	
	!rowcounter = !rowcounter + 1
	{%tn}(!rowcounter,1) = "Variable"
	{%tn}(!rowcounter,2) = "Coefficient"
	{%tn}(!rowcounter,3) = "Std. Error"
	{%tn}(!rowcounter,4) = "LR stat"
	{%tn}(!rowcounter,5) = "Prob."
	!rowcounter=!rowcounter+1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
			
	'Rho
	{%tn}(!rowcounter,1) = "Rho"
	!rowlast = @rows({%coefn})
	!atanrho={%coefn}(!rowlast)
	!rho = @atan(!atanrho)*2/@acos(-1)
	{%tn}(!rowcounter,2) = !rho
	!covar = @sqrt({%covarn}(!rowlast,!rowlast))
	{%tn}.setformat(!rowcounter,2) {%setformat1}
	{%tn}(!rowcounter,3) = !covar
	{%tn}(!rowcounter,4) = !LR	
	{%tn}(!rowcounter,5) = 1-@cchisq(!LR,1)	
	{%tn}.setformat(!rowcounter,5) {%setformat}
	!rowcounter = !rowcounter + 2
	
	{%tn}.setlines(!rowcounter) +d
	!rowcounter=!rowcounter+1	
	{%tn}.setjust(!rowcounter, 1, !rowcounter, 1) left
	%loglik = "Log Likelihood"	
	{%tn}(!rowcounter,1) = %loglik
	{%tn}(!rowcounter,2) = logl
	{%tn}.setformat(!rowcounter,2) {%setformat1}
	%AIC = "   Akaike info criterion"	
	{%tn}(!rowcounter,3) = %AIC
	{%tn}(!rowcounter,5) = aic	
	{%tn}.setformat(!rowcounter,5) {%setformat1}

	!rowcounter=!rowcounter+1
	%SC = "   Schwarz criterion"	
	{%tn}(!rowcounter,3) = %SC
	{%tn}(!rowcounter,5) = sc	
	{%tn}.setformat(!rowcounter,5) {%setformat1}

	!rowcounter=!rowcounter+1	
	%HQ = "   Hannan-Quinn criterion"	
	{%tn}(!rowcounter,3) = %HQ
	{%tn}(!rowcounter,5) = hq	
	{%tn}.setformat(!rowcounter,5) {%setformat1}
	!rowcounter=!rowcounter+1	
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
		
endsub
